Package org.snpeff.interval

# Class Intron

java.lang.Object
org.snpeff.interval.Interval
org.snpeff.interval.Marker
org.snpeff.interval.Intron

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Comparable<Interval>`, `TxtSerializable`

public class Intron extends Marker
Intron

Author:
  pcingola
See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class org.snpeff.interval.Marker

`type`

### Fields inherited from class org.snpeff.interval.Interval

`chromosomeNameOri, end, id, parent, start, strandMinus`

## Constructor Summary

Constructors
Constructor
Description
`Intron()`
`Intron(Transcript parent, int start, int end, boolean strandMinus, String id, Exon exonBefore, Exon exonAfter)`

## Method Summary

Modifier and Type
Method
Description
`void`
`add(SpliceSite ss)`
Add a splice site to the collection
`Intron`
`apply(Variant variant)`
Apply a variant to a marker.
`Intron`
`cloneShallow()`
Perform a shallow clone
`SpliceSiteAcceptor`
`createSpliceSiteAcceptor(int maxSpliceSiteSize)`
Create a splice site acceptor of 'size' length Acceptor site: 3' end of the intron
`SpliceSiteDonor`
`createSpliceSiteDonor(int maxSpliceSiteSize)`
Create a splice site donor of 'maxSize' length Donor site: 5' end of the intron
`SpliceSiteRegion`
`createSpliceSiteRegionEnd(int sizeMin, int sizeMax)`
Create splice site region
`SpliceSiteRegion`
`createSpliceSiteRegionStart(int sizeMin, int sizeMax)`
Create splice site region
`Exon`
`getExonAfter()`
`Exon`
`getExonBefore()`
`int`
`getRank()`
`ArrayList<SpliceSite>`
`getSpliceSites()`
`String`
`getSpliceType()`
`Markers`
`query(Marker marker)`
Query all genomic regions that intersect 'marker'
`void`
`reset()`
`void`
`serializeParse(MarkerSerializer markerSerializer)`
Parse a line from a serialized file
`String`
`serializeSave(MarkerSerializer markerSerializer)`
Create a string to serialize to a file
`void`
`setRank(int rank)`
`boolean`
`variantEffect(Variant variant, VariantEffects variantEffects)`
Calculate the effect of this variant

### Methods inherited from class org.snpeff.interval.Marker

`adjust, applyDel, applyDup, applyIns, applyMixed, clone, codonTable, compareTo, compareToPos, distance, distanceBases, getParent, getType, idChain, idChain, idChain, includes, intersect, isAdjustIfParentDoesNotInclude, isDeferredAnalysis, isShowWarningIfParentDoesNotInclude, minus, query, readTxt, shouldApply, toString, union, variantEffectNonRef`

### Methods inherited from class org.snpeff.interval.Interval

`equals, findParent, getChromosome, getChromosomeName, getChromosomeNameOri, getChromosomeNum, getEnd, getGenome, getGenomeName, getId, getStart, getStrand, hashCode, intersects, intersects, intersects, intersects, intersectSize, isCircular, isSameChromo, isStrandMinus, isStrandPlus, isValid, setChromosomeNameOri, setEnd, setId, setParent, setStart, setStrandMinus, shiftCoordinates, size, toStr, toStringAsciiArt, toStrPos`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### Intron

public Intron()

### Intron

public Intron(Transcript parent, int start, int end, boolean strandMinus, String id, Exon exonBefore, Exon exonAfter)

## Method Details

### add

public void add(SpliceSite ss)
Add a splice site to the collection

### apply

public Intron apply(Variant variant)
Description copied from class: `Marker`
Apply a variant to a marker.

Calculate a the result of a marker, such that newMarker = marker.apply( variant ) variant = Diff( newMarker , marker ) // Differences in sequence

Note: This method may return: - The same marker (this) when genetic coordinates remain unchanged - 'null' if the whole marker is removed by the variant (e.g. a deletion spanning the whole marker)

For these reasons, the method should never be invoked directly. This is why the method is 'private' and 'final'

Overrides:
  `apply` in class `Marker`
Returns:
  The marker result after applying variant

### cloneShallow

public Intron cloneShallow()
Description copied from class: `Marker`
Perform a shallow clone

Overrides:
  `cloneShallow` in class `Marker`

### createSpliceSiteAcceptor

public SpliceSiteAcceptor createSpliceSiteAcceptor(int maxSpliceSiteSize)
Create a splice site acceptor of 'size' length Acceptor site: 3' end of the intron

### createSpliceSiteDonor

public SpliceSiteDonor createSpliceSiteDonor(int maxSpliceSiteSize)
Create a splice site donor of 'maxSize' length Donor site: 5' end of the intron

### createSpliceSiteRegionEnd

public SpliceSiteRegion createSpliceSiteRegionEnd(int sizeMin, int sizeMax)
Create splice site region

### createSpliceSiteRegionStart

public SpliceSiteRegion createSpliceSiteRegionStart(int sizeMin, int sizeMax)
Create splice site region

### getExonAfter

public Exon getExonAfter()

### getExonBefore

public Exon getExonBefore()

### getRank

public int getRank()

### getSpliceSites

public ArrayList<SpliceSite> getSpliceSites()

### getSpliceType

public String getSpliceType()

### query

public Markers query(Marker marker)
Query all genomic regions that intersect 'marker'

Overrides:
  `query` in class `Marker`

### reset

public void reset()

### serializeParse

public void serializeParse(MarkerSerializer markerSerializer)
Description copied from class: `Marker`
Parse a line from a serialized file

Specified by:
  `serializeParse` in interface `TxtSerializable`
Overrides:
  `serializeParse` in class `Marker`

### serializeSave

public String serializeSave(MarkerSerializer markerSerializer)
Create a string to serialize to a file

Specified by:
  `serializeSave` in interface `TxtSerializable`
Overrides:
  `serializeSave` in class `Marker`

### setRank

public void setRank(int rank)

### variantEffect

public boolean variantEffect(Variant variant, VariantEffects variantEffects)
Description copied from class: `Marker`
Calculate the effect of this variant

Overrides:
  `variantEffect` in class `Marker`